let oGraph={i:0}
oGraph.resize = function () {
	oGraph.l=Math.floor(divGraph.getBoundingClientRect().width);
	oGraph.h=Math.floor(divGraph.getBoundingClientRect().height);
	canvGraph.width=oGraph.l;
	canvGraph.height=oGraph.h;
	canvGraph.style.width=oGraph.l+"px";
	canvGraph.style.height=oGraph.h+"px";
	oGraph.trace();
}

oGraph.init = function () {
	oGraph.i=0;
	tGraph=[];
	oGraph.trace();
}

oGraph.trace=function () {
	let l=oGraph.l;
	let h=oGraph.h;
	let marge=h*0.08;
	let hFl=marge*0.2;
	let hGr=hFl*0.5;
	let lGraph=l-marge*2;
	let hGraph=h-marge*2;
	let lGraph2=lGraph-marge*2;
	let hGraph2=hGraph-marge;
	let x0=Math.round(marge)-0.5;
	let y0=Math.round(h-marge)-0.5;
	oGraph.x0=x0;
	oGraph.y0=y0;
	oGraph.lGraph2=lGraph2;
	oGraph.hGraph2=hGraph2;
	let ctx=canvGraph.getContext("2d");
	ctx.fillStyle="white";
	ctx.fillRect(0,0,l,h);
	
	// axes
	ctx.strokeStyle="#777";
	ctx.lineWidth=0.5;
	ctx.beginPath();
	ctx.moveTo(x0,y0);
	ctx.lineTo(x0,y0-hGraph);
	ctx.lineTo(x0-hFl,y0-hGraph+hFl);
	ctx.moveTo(x0,y0-hGraph);
	ctx.lineTo(x0+hFl,y0-hGraph+hFl);
	
	ctx.moveTo(x0,y0);
	ctx.lineTo(x0+lGraph,y0);
	ctx.lineTo(x0+lGraph-hFl,y0-hFl);
	ctx.moveTo(x0+lGraph,y0);
	ctx.lineTo(x0+lGraph-hFl,y0+hFl);
	ctx.stroke();
	
	ctx.fillStyle="#777";
	ctx.font=hFont*0.7+"px Arial";
	ctx.textAlign="left";
	ctx.fillText ("Fréquence de l'allèle "+vMod.nomAll1,0,y0-hGraph-hFl);
	ctx.textAlign="center";
	ctx.fillText ("Génération",x0+lGraph,y0+hFont);
	
	// graduations
	ctx.textAlign="right";
	for (let i=10;i<=100;i+=10) {
		let y=y0-i*hGraph2/100;
		ctx.fillRect(x0-hGr/2,y,hGr,1);
		ctx.fillText(virg(i/100),x0-hGr*1.5,y+hFont*0.3);
		ctx.fillRect(x0,y,lGraph2,0.15);
	}
	
	let pas;
	let n=vMod.nGen;
	if (n>5000) {pas=1000} 
	else if (n>1000) {pas=500}
	else if (n>500) {pas=100} 
	else if (n>100) {pas=50}
	else if (n>50) {pas=10}
	else if (n>10) {pas=5}
	else {pas=1}
	ctx.textAlign="center";
	for (let i=0;i<=n;i+=pas) {
		let x=x0+i*lGraph2/n;
		ctx.fillRect(x,y0-hGr/2,1,hGr);
		ctx.fillText (i,x,y0+hFont*0.9);
	}
	
	// courbes	
	if (tGraph.length>0) {
		for (let j=0;j<tGraph.length;j++) {
			ctx.beginPath();
			if (j==oGraph.i) {
				ctx.strokeStyle="black";
				ctx.lineWidth=1;
			} else {
				ctx.strokeStyle="#777"
				ctx.lineWidth=0.5;
			}
			for (let i=0;i<tGraph[j].length;i++) {
				let f=tGraph[j][i];
				let y=y0-f*hGraph2;
				let x=x0+i*lGraph2/n;
				if (i==0) {
					ctx.moveTo(x,y);
				} else {
					ctx.lineTo(x,y);
				}
			}
			ctx.stroke();
		}
	}
	
	// affichage de la dernière fréquence
	if ((tGeno.length>0)||(vMod.eff==0)) { // seulement s'il y a des survivants
		let x=x0+lGraph2+hFont;
		let y=y0-oGen.freq1*hGraph2;
		if (oGen.freq1>0.02) {y+=hFont*0.2}
		else if (oGen.freq1<0.01) {y-=hFont*0.3}
		ctx.textAlign="left";
		ctx.fillText ("f = "+virg (Math.round(oGen.freq1*10000)/10000),x,y);
	}
	
}

oGraph.hideCoords = function () {
	hide(divCoords);
}

oGraph.mousemove = function (e) {
	oGraph.hideCoords ();
	let xEcran=e.clientX;
	let yEcran=e.clientY;
	var rect = canvGraph.getBoundingClientRect();
	let x=xEcran-rect.left;
	let y=yEcran-rect.top;
	let xx=x-oGraph.x0;
	let yy=oGraph.y0-y;
	let f=yy/oGraph.hGraph2;
	if ((f<0)||(f>1)) {return false}
	let g=xx/oGraph.lGraph2;
	if ((g<0)||(g>1)) {return false}
	g=Math.round(g*vMod.nGen);
	show(divCoords);
	divCoords.style.left=xEcran+"px";
	divCoords.style.top=yEcran+"px";
	divCoords.innerHTML="Gén° = "+g+"<br>f = "+virg(Math.round(f*10000)/10000);
}

oGraph.store = function () {
	if (vMod.eff>0) {
		if (tGeno.length>0) {
			tGraph[oGraph.i].push (oGen.freq1);
		}
	} else {
		tGraph[oGraph.i].push (oGen.freq1);
	}
}